// Créé par Pierre THOMAS, inspiré par d'autres plugins (Décembre 2019)
// Version 1: Pour plusieurs accordéons diatoniques

import QtQuick 2.0
import MuseScore 3.0

MuseScore   {
   version: "3.0"
   description: "Tablature d'accordéon diatonique Sol/Do Galaad 25 touches"
   menuPath: 'Plugins.Tablature pour diato Galaad 25 touches'
   onRun:         {
                  if (typeof curScore === 'undefined')Qt.quit();
                  // Pos = paramètre de réglage général en hauteur de la position verticale des N°; >0 --> vers le bas
                  var Pos = 0;
                 // Position 1er N° poussé
                  var Pous1 = Pos;
                 // Position 1er N° tiré
                  var Tire1 = Pos + 5.8;
                 // Décalage horizontal N° à 1 chiffre
                  var H0 = 0;
                // Décalage horizontal N° à 2 chiffres; négatif --> vers la gauche
                  var H1 = -1;
                // Décalage horizontal N° 3ème rangée; négatif --> vers la gauche
                  var H3 = -0.4;
                  
                  var Decal = 0;
                  
                  var Curseur = curScore.newCursor();
                  
                  // Début boucle instruments
                  for (var Instrument = 0; Instrument < curScore.nstaves; Instrument = Instrument + 1)
                        {
                        Curseur.staffIdx = Instrument ;
                        Curseur.voice = 0 ;
                        Curseur.rewind(0);
                                                     
                              // Début boucle N° poussés
                              while (Curseur.segment)
                                    {
                                    var Numero = newElement(Element.STAFF_TEXT);
                                    if (Curseur.element && Curseur.element.type === Element.CHORD)
                                          {
                                          var Midi = Curseur.element.notes[0].pitch;
                                          
                                          switch (Midi)
                                                {
                                                case 50: Numero.text = "2"; Decal = H0 ; break ;
                                                case 52: Numero.text = "1'"; Decal = H0 ; break ;
                                                case 55: Numero.text = "3\n2'"; Decal = H0 ; break ;
                                                case 59: Numero.text = "4"; Decal = H0 ; break ;
                                                case 60: Numero.text = "3'"; Decal = H0 ; break ;
                                                case 62: Numero.text = "5"; Decal = H0 ; break ;
                                                case 63: Numero.text = "1''"; Decal = H3 ; break ; 
                                                case 64: Numero.text = "4'"; Decal = H0 ; break ;
                                                case 67: Numero.text = "6\n5'"; Decal = H0 ; break ;
                                                case 68: Numero.text = "2''"; Decal = H3 ; break ;
                                                case 71: Numero.text = "7"; Decal = H0 ; break ;
                                                case 72: Numero.text = "6'"; Decal = H0 ; break ;
                                                case 74: Numero.text = "8"; Decal = H0 ; break ;
                                                case 75: Numero.text = "3''"; Decal = H3 ; break ;
                                                case 76: Numero.text = "7'"; Decal = H0 ; break ;
                                                case 79: Numero.text = "9\n8'"; Decal = H0 ; break ;
                                                case 80: Numero.text = "4''"; Decal = H3 ; break ;
                                                case 83: Numero.text = "10"; Decal = H1 ; break ;
                                                case 84: Numero.text = "9'"; Decal = H0 ; break ;
                                                case 86: Numero.text = "11"; Decal = H1 ; break ;                                               
                                                case 88: Numero.text = "10'"; Decal = H1 ; break ;
                                                        }
                                                }
                                    Numero.autoplace = false ;
                                    Curseur.add(Numero) ;
                                    Numero.placement = Placement.BELOW ;
                                    Numero.offsetY = Pous1 ;
                                    Numero.offsetX = Decal ;
                                    Curseur.next();      
                                    } // Fin de la boucle N° poussés
  
                        Curseur.rewind(0);                        
             
                              // Début boucle N° tirés
                              while (Curseur.segment)
                                    {
                                    var Numero = newElement(Element.STAFF_TEXT);
                                    if (Curseur.element && Curseur.element.type === Element.CHORD)
                                          {
                                          var Midi = Curseur.element.notes[0].pitch;
                                          
                                          switch (Midi)
                                                {
                                                case 50: Numero.text = "1"; Decal = H0 ; break ;
                                                case 54: Numero.text = "2"; Decal = H0 ; break ;
                                                case 55: Numero.text = "1'"; Decal = H0 ; break ;
                                                case 57: Numero.text = "3"; Decal = H0 ; break ;
                                                case 59: Numero.text = "2'"; Decal = H0 ; break ;
                                                case 60: Numero.text = "4"; Decal = H0 ; break ;
                                                case 61: Numero.text = "1''"; Decal = H3 ; break ;
                                                case 62: Numero.text = "3'"; Decal = H0 ; break ;
                                                case 64: Numero.text = "5"; Decal = H0 ; break ;
                                                case 65: Numero.text = "4'"; Decal = H0 ; break ;
                                                case 66: Numero.text = "6"; Decal = H0 ; break ;
                                                case 69: Numero.text = "7\n5'"; Decal = H0 ; break ;
                                                case 70: Numero.text = "2''"; Decal = H3 ; break ;
                                                case 71: Numero.text = "6'"; Decal = H0 ; break ;
                                                case 72: Numero.text = "8"; Decal = H0 ; break ;
                                                case 73: Numero.text = "3''"; Decal = H3 ; break ;
                                                case 74: Numero.text = "7'"; Decal = H0 ; break ;
                                                case 76: Numero.text = "9"; Decal = H0 ; break ;
                                                case 77: Numero.text = "8'"; Decal = H0 ; break ;
                                                case 78: Numero.text = "10"; Decal = H1 ; break ;
                                                case 81: Numero.text = " 9'\n11"; Decal = H1 ; break ;
                                                case 82: Numero.text = "4''"; Decal = H3 ; break ;
                                                case 83: Numero.text = "10'"; Decal = H1 ; break ;
                                                        }
                                                }
                                    Numero.autoplace = false ;
                                    Curseur.add(Numero) ;
                                    Numero.placement = Placement.BELOW ;
                                    Numero.offsetY = Tire1 ;
                                    Numero.offsetX = Decal ;
                                    Curseur.next();      
                                    } // Fin de la boucle N° tirés
                       
                        } // Fin de la boucle instrument      
                  Qt.quit();
                  }
            }
